// Dobot RX -- Arduino TX (Mega pin 18 serial1 TX1) Note that some MEGA board's label is wrong
// Dobot TX -- Arduino RX (Mega pin 19 serial1 RX1) Note that some MEGA board's label is wrong
// Dobot GND -- Arduion GND

#include "dobotMag.h"

dobotMag bot(true);  // true=debug mode

const int SW_pin = 8; // digital pin connected to switch output. press down=LOW
const int X_pin = 0; // analog pin connected to X output
const int Y_pin = 1; // analog pin connected to Y output
const int DRILL_pin = 22; // DC drill on/off

void setup() {
    pinMode(SW_pin, INPUT_PULLUP); // pullup mode must be used for the joystick press switch, press down=0
    pinMode(DRILL_pin, OUTPUT);
    
    Serial.begin(115200);  // serial -- connect to PC for debug
    Serial1.begin(115200); // serial1 -- connect to Dobot
    bot.setQueuedCmdStartExec();
    bot.setQueuedCmdClear();
    bot.setPTPJointParams();
    bot.setPTPCoordinateParams();
    bot.setPTPCommonParams(100,100); // set velocity, acceleration (0-100)
    bot.setPTPJumpParams(50,100); // set lift height, maximum lift height
    bot.setHomeParams(250,0,50,0); // set home position, default 250,0,50,0
    bot.setHome();
    delay(15000);
}

void loop() 
{
  while (true) {
    bot.moveTo(250,0,50,0,MODE_PTP_MOVJ_XYZ,true);
    delay(2000);

    if (bot.getPose()) {
      Serial.print("pose: ");
      Serial.print(bot.x);Serial.print(" ");
      Serial.print(bot.y);Serial.print(" ");
      Serial.print(bot.z);Serial.print(" ");
      Serial.print(bot.r);Serial.print(" ");
      Serial.print(bot.j1);Serial.print(" ");
      Serial.print(bot.j2);Serial.print(" ");
      Serial.print(bot.j3);Serial.print(" ");
      Serial.println(bot.j4);
    }

    bot.moveTo(250,0,40,0,MODE_PTP_MOVJ_XYZ,true);
    delay(2000);
        
    if (bot.getPose()) {
      Serial.print("pose: ");
      Serial.print(bot.x);Serial.print(" ");
      Serial.print(bot.y);Serial.print(" ");
      Serial.print(bot.z);Serial.print(" ");
      Serial.print(bot.r);Serial.print(" ");
      Serial.print(bot.j1);Serial.print(" ");
      Serial.print(bot.j2);Serial.print(" ");
      Serial.print(bot.j3);Serial.print(" ");
      Serial.println(bot.j4);
    }
  }
}   
